#!/bin/bash


starttime=`date +%Y-%m-%d_%H:%M:%S`
echo "-- Build started at: ${starttime}"


echo "-- Initialize build environment"
m4 -D__CWD__=`pwd` Makefile.global.m4 > Makefile.global
m4 -D__CWD__=`pwd` buildconfig.default.m4 > buildconfig.default

buildinfo="output/staging/buildconfig.info"
buildinfo_m4="output/staging/buildconfig.info.m4"

# Store some information for use in the build information of the image.
sed "s/BUILD_START=.*/BUILD_START=${starttime}/" "${buildinfo_m4}" > "${buildinfo}"
sed "s/BUILD_HOST=.*/BUILD_HOST=`uname -n`/" "${buildinfo_m4}" > "${buildinfo}"
sed "s/BUILD_USER=.*/BUILD_USER=$USER/" "${buildinfo_m4}" > "${buildinfo}"
echo "BINARY_PACKAGE=1" >> "${buildinfo}"

### Build all components
echo "-- Build all components"
make

### Create image
echo "-- Create image"
make image


### Build ready
endtime=`date +%Y-%m-%d_%H:%M:%S`
echo "-- Build completed at ${endtime}"
echo "BUILD_END=${endtime}" >> "${buildinfo}"


