package provide buildsystem 1.0

namespace eval buildsystem {
      variable globalbuildcfg
    
  namespace export read_servers

}

# fills in globalbuildcfg array

proc buildsystem::read_servers {filename} {
    variable globalbuildcfg

    log::log debug "Reading build config" 
    log::log debug "Opening $filename"
    set infile [open $filename r]

    while { [gets $infile line] >= 0} {
	# is line not empty
	if [string length $line] {

	    # line starting with # are treated as comment
	    if [regexp {^#} $line] {
		continue
	    }

	    #split name from the server *uri*
	    set parts [split $line "="]
	    lassign $parts name address

	    #split the protocol from the server *uri*
	    regexp {[a-zA-z0-9]+} $address proto

	    regexp "(\[^$proto:\])(.*)" $address serveraddress

	    #now check if the server part has a workspace included, otherwise add the content of the P4CLIENT environment variable
	    if [string match "p4" $proto] {
		if {[regexp ".+/.+" $serveraddress] != 1} {
		    continue
	        }
	    }

       log::log debug "Servername: $name Serverprotocol: $proto Path: $serveraddress"

       set server(proto) $proto
       set server(serveraddress) $serveraddress
       set globalbuildcfg($name) [array get server]

       unset line address proto serveraddress       
       }

    }

    close $infile

    log::log debug "Reading build config done" 
    return [array get globalbuildcfg]
}

# returns arraylist of globalbuildcfg

proc buildsystem::getGlobalbuildcfg {} {
    variable globalbuildcfg
    return [array get globalbuildcfg]

}
