package provide buildsystem 1.0

namespace eval buildsystem {
  variable globalcomponentlst
    
  namespace export read_components
}

# fills in variable globalcomponentlst array

proc buildsystem::read_components {filename} {
    variable globalcomponentlst

    log::log debug "Reading components" 
    log::log debug "Opening $filename"
    set infile [open $filename r]

    while { [gets $infile line] >= 0} {
	# is line not empty
	if [string length $line] {
	    # line starting with # are treated as comment
	    if [regexp {^#} $line] {
		continue
	    }
	    if { [string first "#" $line] > 0 } {
		set parts [split $line "#"]
		lassign $parts line comment
	    }
	    #split name from the server path
	    set parts [split $line "="]
	    lassign $parts componentname componentpath

	    #split the component from the server path
	    regexp {[a-zA-z0-9]+} $componentpath servername

	    regexp "(\[^$servername:\])(.*)" $componentpath serverpath

	    log::log debug "Componentname: $componentname Servername: $servername Componentpath: $serverpath"

	    set component(servername) $servername
	    set component(serverpath) [string trim $serverpath]
	    set globalcomponentlst($componentname) [array get component] 
	}
    }
    close $infile
    log::log debug "Reading components done"
    
    return [array get globalcomponentlst]
}
