package provide buildsystem 1.0

namespace eval buildsystem {
  namespace export read_hardcocfg
}

proc buildsystem::read_hardcocfg {filename hardcocfgarray} {

    upvar $hardcocfgarray hardcocfg

    log::log debug "Reading hardco configuration"
    if [file exists $filename] { 
	log::log debug "Opening $filename"
	set infile [open $filename r]

	while { [gets $infile line] >= 0} {
	    # is line not empty
	    if [string length $line] {
		# line starting with # are treated as comment
		if [regexp {^#} $line] {
		    continue
		}
	    }

	    set parts [split $line "="]
	    lassign $parts configname configvalue

	    set hardcocfg($configname) $configvalue
	}
    }
}
