#!/bin/bash
# runtest.sh
DIRECTORY=$(cd `dirname $0` && pwd)
echo "Switching to $DIRECTORY"
cd $DIRECTORY

source env.sh

echo "**********************************************************"
echo "Running tests in `pwd`"
echo "Current date is `date`"
echo "**********************************************************"

./initializetest.sh

echo "**** Launching unit tests"
CONFIGLOCATION=`cat test.configlocation`
CONFIGVERSION=`cat test.configversion`
SPIN=`cat test.spin`
echo "<?xml version=\"1.0\"?>" > $TESTRESULTSDIR/result.xml
echo "<testrun config=\"$CONFIGLOCATION\" configversion=\"$CONFIGVERSION\" spinnumber=\"$SPIN\">" >> $TESTRESULTSDIR/result.xml
for dir in *
do
  if [ -d "$dir" ]; then
    NEWCOMPONENT=1
    echo "**** Launching unit test in $dir"
    for file in "$dir"/*_testplan.sh
    do
      TESTPLANTYPE=`"$file" --type;`
      if [ -f "$file" ] && [ $TESTPLANTYPE = $TESTTYPE ]; then
        if [ $NEWCOMPONENT = 1 ]; then
          NEWCOMPONENT=0
          CVERSION=`cat $dir/component.version | sed s/export\ COMPONENT_VERSION=//`
          CID=`cat $dir/component.name | sed s/export\ COMPONENT_NAME=//`
          echo "<component id=\"$CID\" version=\"$CVERSION\">" >> $TESTRESULTSDIR/result.xml
        fi
        echo "**** Launching testplan $file"
        "$file";
        TESTPLAN_NAME=`basename $file .sh`;
        cat "$TESTRESULTSDIR/$dir/${TESTPLAN_NAME}_result.xml" | grep -v "<?xml version=" | grep -v "testrun>" | grep -v "<testrun config" | grep -v "<component id" | grep -v "</component" >> $TESTRESULTSDIR/result.xml;
      fi
    done
    if [ $NEWCOMPONENT = 0 ]; then
      NEWCOMPONENT=0
      echo "</component>" >> $TESTRESULTSDIR/result.xml
    fi
  fi
done
echo "</testrun>" >> $TESTRESULTSDIR/result.xml

./cleanuptest.sh



