#!/bin/bash
# testsources.sh

# load the environment variables
source ../env.sh
source ./component.location
source ./component.name
source ./component.version

case $TESTTYPE in
  remote)
    # setup pcb environment
    export PCB_SYS_BUS="pcb://ipc:{/var/run/pcb_sys}"
    # variable used in the .so unit tests
    export TESTRESULTFILE=$REMOTETESTRESULTSDIR/$COMPONENT_NAME/result.xml
    ;;
  remote_standalone)
    # setup pcb environment
    export PCB_SYS_BUS="pcb://ipc:{/var/run/pcb_sys}"
    # variable used in the .so unit tests
    export TESTRESULTFILE=$REMOTETESTRESULTSDIR/$COMPONENT_NAME/result.xml
    ;;
  local)
    ;;
  local_standalone)
    # setup pcb environment
    export PCB_SYS_BUS="pcb://ipc:{/tmp/sysbus}"
    export SYS_BUS="/tmp/sysbus"
    export PCB_PLUGIN_PATH=$STAGINGDIR/usr/lib/pcb
    export PATH=$PATH:$STAGINGDIR/bin
    export LD_LIBRARY_PATH=$STAGINGDIR/lib
    # variable used in the .so unit tests
    export TESTRESULTFILE=$TESTRESULTSDIR/$COMPONENT_NAME/result.xml
    ;;
  *)
    echo "*** Unknown test type ($TESTTYPE)"
    ;;
esac
