#!/bin/bash

DIR_1=$1
DIR_2=$2

# This lists all files in both directories, appends a "+ or -", sorts all lines and finally sorts out all consecutive lines that match
(cd $DIR_1; find . | sed 's/\(.*\)/\1:-/' ; cd $DIR_2; find . | sed 's/\(.*\)/\1:+/' ) | sort | gawk --posix '

BEGIN {
    FS=":";
    previous_1="";
} 

/^([[:graph:]]+:[+-])$/ { 
    if ( previous_1 != $1 ) {
        if ( previous_1 != "" ) { 
            print previous_2 previous_1;
	}
        previous_1 = $1;
        previous_2 = $2;
    } else { 
        previous_1=""
    } 
} 

END{
    if ( previous_1 != "" ) { 
        print $2 $1;
    }
} '

# <&0

