#!/usr/bin/perl

use strict;

my $indir = shift;
my $outdir = shift;

print "Input dir: $indir\n";
print "Output dir: $outdir\n";

my @dircontent = `ls -1 $indir`;

foreach my $fname (@dircontent) {
	chomp $fname;
	my $rc = open INFILE, "$indir/$fname";
	die "Error opening file $indir/$fname" unless $rc;
	my $rc2 = open OUTFILE, ">", "$outdir/$fname";
	die "Error opening file $indir/$fname" unless $rc2;
	print "Processing: $indir/$fname -> $outdir/$fname\n";

	my $line;

	while ($line = <INFILE>) {
		if ($line =~ /^include (<|")(.*)(>|")$/) {
			print "Including $2\n";
			my $rc3 = open INCFILE, "$indir/$2";
			die "Error including file $indir/$2\n" unless $rc3;
			while ($line = <INCFILE>) {
				print OUTFILE $line;
			}
			close INCFILE;
		}
		print OUTFILE $line;
	};
	close INFILE;
	close OUTFILE;
}
