#!/usr/bin/php
<?php 
if ($argc != 3) {
    echo "Syntax: " . $argv[0] . " version.txt version (4.5.0)\n";
    return 1;
}

$version=$argv[2];

$cmp_list="/home/davidc/ws_w1_build/build/MAIN/component.lst";
//$ver_txt="/home/davidc/version.txt";
$ver_txt=$argv[1];

$db = new mysqli("127.0.0.1", "davidc", "readonly", "sahbugs", 10120, null);

$sql    = "SELECT `bug_id`, `cf_p4fixes` FROM `bugs` WHERE `fixedversion`='$version' AND `bug_status`='MERGED'";
$result = $db->query($sql);

$drop_fd = fopen("/tmp/drop_file", 'a+');

$p4_pattern     ="/^(\/\/.*)$/";
$rel_pattern    = "/^\/\/depot(.*)\/(REL\/.*)|(MAIN)$/";
$cmp_pattern = "/^(.*)=(.*):(.*)$/";

$cmp_path_arr = Array('label', 'path');
$cmp_path_arr['label'] = Array();
$cmp_path_arr['path'] = Array();


$rel_list = Array();
echo "Perfix info\n";
while ($row = $result->fetch_object()) {
    $bugid = $row->bug_id;
    $p4fix = trim($row->cf_p4fixes);
    $fixes = preg_split('/\n/', $p4fix);
    foreach ($fixes as $fix) {
        $fix = trim($fix);
        if (preg_match($p4_pattern, $fix, $matches) > 0) {
            $fix = $matches[1];
            if (preg_match("/^(\/\/.*)(\/|\/[\.]+)$/", $fix, $matches) > 0) {
                $fix = $matches[1];
            }
            echo "$fix\n";
            if (0 < preg_match($rel_pattern, $fix, $matches)) {
                array_push($rel_list, $fix);
            } else {
                fprintf($drop_fd, "SKIPPING LOOKUP FOR: $fix\n");
            }
        } else {
            fprintf($drop_fd, "DROPPING: Bugid $bugid -> $fix\n");
        }
    }
}
$db->close();
fclose($drop_fd);
echo "\n\n";

$fd = fopen($cmp_list, 'r');
while($buf = fgets($fd)) {
    if (null == ($buf = ltrim($buf))) {
        continue;
    }   
    if ($buf[0] == '#') {
        continue;
    }   
    if (0 < ($res = preg_match($cmp_pattern, $buf, $matches))) {
        if ($matches[2] == 'w1') {
            array_push($cmp_path_arr['label'], $matches[1]);
            array_push($cmp_path_arr['path'], $matches[3]);
        }   
    }   
}
fclose($fd);

echo "Looking up rels in: $ver_txt\n";
foreach ($rel_list as $buf) {
    $key = max_str_cmp($buf, $cmp_path_arr);
    if ($key > 0) {
        $label = $cmp_path_arr['label'][$key];
        $label_path = $cmp_path_arr['path'][$key];
        $version = get_version_from_rel($label_path, $buf);
        $replace = make_replace_string($label, $version);
        $found = search_for_component($ver_txt, $replace);
        printf("Present %s : %s\n", $replace, ($found ? "yes" : "no"));
    } else {
        echo "Error retrieving label for rel $buf\n";
    }

}

function search_for_component($ver_txt, $cmp) {
    $hit = 0;
    if (null == ($fd = fopen($ver_txt, "r"))) {
        echo "Error opening file: $ver_txt\n";
        return -1;
    }
    while($buf = fgets($fd)) {
        $buf = trim($buf);
        if (!strcmp($buf, $cmp)) {
            return(1);
        }
    }
    fclose($fd);
    return $hit; 
}

function make_replace_string($label, $version) {
    $replace = $label . "=" . $version;
    return $replace;
}

function make_search_string($label, $version) {
    $search = null;
    $pattern = "/^(.*REL\/).*$/";
    if (0 < ($res = preg_match($pattern, $version, $matches))) {
        $search = $label . "=" . $matches[1];
    }
    return $search;
}

function get_version_from_rel($label_path, $rel) {
    $version = null;
    $esc     = "/";
    $pattern = "/^\/\/depot" . addcslashes($label_path, $esc) . "\/(.*)$/";
    if (0 < ($res = preg_match($pattern, $rel, $matches))) {
        $version = $matches[1];
    }
    return $version;
}

function max_str_cmp($rel, $path_arr) {
    $path_list = $path_arr['path'];
    $max_count = 0;
    $sel_key   = -1;
    $label     = null;

    foreach ($path_list as $key => $path) {
        $depth = count_path_depth($rel, $path);
        if ($depth > $max_count) {
            $max_count = $depth;
            $sel_key   = $key;
        }
    }
    return $sel_key;
}

function count_path_depth($path1, $path2) {
    $path1_arr = split('/', $path1);
    $path2_arr = split('/', $path2);
    $depth = 0;

    $len = count($path1_arr);
    for ($i = 1; $i < $len; $i++) {
        $j = $i + 2;
        if (!isset($path1_arr[$j]) || !isset($path2_arr[$i])) {
            return $depth;
        }

        if (strcmp($path1_arr[$j], $path2_arr[$i])) {
            return $depth;
        }
        $depth++;
    }
}


?>
