#!/usr/bin/perl

if (($#ARGV) != 0) {
	print "make a sahft config.\n";
	print "Usage: ./makesahft.pl <path_to_ft_config_from_rel_branch>\n";
	print "Example: ./makesahft.pl ft/lbv2fr/zte_h202n/ft_multi_sip_normal/\n";
	print "Note: the target ftsah config should not exist before running the script !\n";
	exit 0;
}

$what = shift;
$to = $what;
$to =~ s#ft_multi#ftsah_multi#g;

$filename = "$to" . "/nemo-defaults.odl";
$p4filename = "//depot/$filename";

$command = "p4 integrate -f $what... $to...\n";
print "execute: $command";
system "$command";

print "filename: $filename";
print "p4 path to filename: $p4filename";

print "\n";
$command = "p4 edit $p4filename\n";
print "execute: $command";
system "$command";

#read in file
open FILE, $filename or die $!;
@lines = <FILE>;
close FILE;

# check if we (need to) replace something
@newfile = ();
foreach $line (@lines) {
  $oldline = $line;
  $line =~ s#parameter VLANID\=835#parameter VLANID\=130#g;
  $line =~ s#parameter VLANID\=851#parameter VLANID\=131#g;
  $line =~ s#parameter VLANID\=838#parameter VLANID\=132#g;
  $line =~ s#parameter VLANID\=840#parameter VLANID\=132#g;
  $line =~ s#parameter VLANID\=832#parameter VLANID\=133#g;
  if ($oldline ne $line) {
    print "set in nemo-defaults.odl : $line";  
  }
  push(@newfile, $line);
}

open FILE, "+>", $filename or die $!;
print FILE @newfile;
close FILE;

