class Ffmpeg_OpenSource < OpenSource

	@component="ffmpeg"
	@source_package="ffmpeg-svn15004.tar.bz2"
	@source_dir="ffmpeg-svn15004"
	@activation_flag="_APPLI_FLG_FFMPEG_"
	@base_dir=Pathname.new(__FILE__).parent.parent
	@configure_options = Hash.new
	@patchlist = [ \
		"ffmpeg.patch",\
		"ffmpeg_llrint.patch",\
		"ffmpeg_annexb.patch",\
		"netgem/libavcodec/aac_ac3_parser.c.netgem.patch",\
		"netgem/libavcodec/mpeg4video_parser.c.netgem.patch",\
		"netgem/libavcodec/parser.c.netgem.patch",\
		"netgem/libavcodec/h264.c.netgem.patch",\
		"netgem/libavcodec/h264_parser.c.netgem.patch",\
		"netgem/libavcodec/aac_ac3_parser.h.netgem.patch",\
		"netgem/libavformat/mov.c.netgem.patch",\
#		"netgem/libavformat/mpegts.c.netgem.patch",\
		"netgem/libavformat/utils.c.netgem.patch",\
		"netgem/libavformat/avidec.c.netgem.patch",\
		"sah/libavformat/avformat.h.sah.patch",\
		"sah/libavformat/utils.c.sah.patch",\
		"sah/libavformat/mov.c.sah.patch",\
		]

	@configure_options["common"] = "\
			--disable-ffserver \
			--disable-ffmpeg \
			--disable-ffplay \
			--disable-ipv6 \
			--disable-vhook \
			--disable-protocols \
			--disable-network \
			--disable-bsfs \
			--disable-static \
			--enable-pthreads \
			--disable-indevs \
			--disable-outdevs \
			--disable-filters \
			--disable-zlib \
			--disable-bzlib \
			--disable-encoders \
			--disable-muxers \
			--disable-demuxers \
			--disable-parsers \
			--disable-decoders \
			--enable-protocol=file \
			--enable-demuxer=avi \
			--enable-demuxer=mov \
			--enable-demuxer=mp3 \
			--enable-demuxer=mpegps \
			--enable-demuxer=mpegvideo \
			--enable-demuxer=wav \
			--enable-demuxer=ac3 \
			--enable-demuxer=aac \
			--enable-demuxer=aiff \
			--enable-demuxer=amr \
			--enable-demuxer=avisynth \
			--enable-demuxer=dts \
			--enable-demuxer=eac3 \
			--enable-demuxer=flac \
			--enable-demuxer=flv \
			--enable-demuxer=gsm \
			--enable-demuxer=h264 \
			--enable-demuxer=m4v \
			--enable-demuxer=matroska \
			--enable-demuxer=mov \
			--enable-demuxer=mpegts \
			--enable-demuxer=mpegtsraw \
			--enable-demuxer=ogg \
			--enable-demuxer=swf \
			--enable-decoder=mp3 \
			--enable-encoder=pcm_s16be \
			--enable-parser=mpegaudio \
			--enable-parser=mpegvideo \
			--enable-parser=ac3 \
			--enable-shared \
			--enable-bsf=h264_mp4toannexb \
			--prefix=#{@base_dir}/out				\
			--shlibdir=#{@base_dir}/out/%GCC_MACHINE%/%GCC_VERSION%/%RELEASE%/lib			\
			--incdir=#{@base_dir}/h					\
			"

	@configure_options["release"] = "\
			--extra-cflags=\"-O2 \" \
			--enable-small \
			--disable-debug"

	@configure_options["debug"] = "\
			--enable-debug=2 \
			--enable-small \
			--disable-optimizations \
			--disable-stripping"

	@configure_options["sh4-linux"] = "\
			--enable-cross-compile \
			--cross-prefix=sh4-linux- \
			--arch=sh4 \
			--extra-cflags=\"-fno-strict-aliasing -fno-common -fstack-protector -Wshadow -funsigned-char -pipe -ml -m4 -Wall -Wundef \" \
			"

	@configure_options["mipsel-linux-uclibc"] = "\
			--enable-cross-compile \
			--cross-prefix=mipsel-linux-uclibc- \
			--arch=mipsel \
			--extra-cflags=\"-fpic -fno-strict-aliasing -fno-common -Wshadow -funsigned-char -pipe -Wall -Wundef \" \
			"

	@configure_options["i486-linux-gnu"] = "\
			--disable-mmx \
			"

end
