/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_BUT_H__
#define __BSP_BUT_H__

/**
 * \file bsp_but.h Bsp Button description.
 *
 * This file allow to describe Bsp Button.
*/

/*
 * Includes
 * ~~~~~~~~
 */

//#include "../drivers/char/button/khco_button_api.h"
//#include <include/api_inc/khco_button_api.h>
typedef enum _BOARD_BUTTON_NAME
{
	kButtonReset,
	kButtonReboot,
	kButtonPairing,
	kButtonWifiOn,
	kButtonWakeupDisplay,
	kButtonUp,
	kButtonDown,
	kButtonOk,
	kButtonEnd
} BOARD_BUTTON_NAME;

/** the enum the actions/states of buttons */
typedef enum _BOARD_BUTTON_STATE
{
	kButtonReleased,
	kButtonPushed,
} BOARD_BUTTON_STATE;


/*
 * Functions
 * ~~~~~~~~~
 */

/** Get BUTTON state. */
BOARD_BUTTON_STATE kSysGetButtonState(BOARD_BUTTON_NAME _but);

/** register callback for interrupt. */
void kSysButtonRegisterCb (BOARD_BUTTON_NAME _nameUser, void *ptr);

/** deregister callback for interrupt. */
void kSysButtonUnRegisterCb (BOARD_BUTTON_NAME _nameUser);

#endif

// vim:ts=5:
