/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_FIRMWARE_H
#define __BSP_FIRMWARE_H

/**
 * \file bsp_firmware.h Bsp Firmware format description.
 *
 * This file allow to describe Bsp Firware format.
 */

/*
 * Typedefs
 * ~~~~~~~~
 */

/**
 * \name Enum typedefs.
 */
/*@{*/
/** Typedef on enum bsp_firmwrae_subPart_enu. */
typedef enum bsp_firmware_subPart_enu		bsp_firmware_subPart_e;
/** Typedef on enum bsp_firmware_type_enu. */
typedef enum bsp_firmware_type_enu			bsp_firmware_type_e;
/*@}*/

/** \name bsp_env_firware struct Typedefs.
 */
/*@{*/
/** \link bsp_env_firmware_str bsp_env_firmware struct \endlink typedef. */
typedef struct bsp_env_firmware_str		bsp_env_firmware_s;
/** \link bsp_env_firmware_str bsp_env_firmware struct \endlink pointer typedef. */
typedef struct bsp_env_firmware_str		*pBsp_env_firmware_s;
/*@}*/

/*
 * Enums
 * ~~~~~
 */

/** Type Firmware type. 
 *
 *	The order of this enum must respect the same one of 
 *		- jffs-make\api-utils\api-upgrade\lib\flash_format.h and
 *		- dsa\crypt\flash_format.h
 *
 *		=> typedef enum __eFirmwareType { OPERATIONAL_FW, RESCUE_FW, NETWORK_FW, INVALID_FW} eFirmwareType;
 *			because this enum is used by UPGRADE API to test header of binary file AND
 *			this enum is used by cryptdsa tool to genere these binary file at end of compilation (the dsa module isn't in delivry SDK)
 **/
enum bsp_firmware_type_enu {
	/** Operational. */
	BSP_Firmware_type_operational,

	/** LanRescue. */
	BSP_Firmware_type_rescue,

	/** Rescue. */
	BSP_Firmware_type_lanrescue,

	/** Max. */
	BSP_Firmware_type_max,

	/** Unknown. */
	BSP_Firmware_type_unknown	= 0xff,
};

/** Bsp_env_firmware_str.
 *
 * 	This struct manage Firmware Information.
 */
struct bsp_env_firmware_str {
	/** Struct type. */
	struct {
		/** Name. */
		char						*name;
	}Type[BSP_Firmware_type_max];
};

/*
 * Functions
 * ~~~~~~~~~
 */

/** Get TypeBoard. */
bsp_firmware_type_e bsp_get_typeFirmware(	void);

#endif

// vim:ts=5:
