/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_LED_H__
#define __BSP_LED_H__

/**
 * \file bsp_led.h Bsp Led description.
 *
 * This file allow to describe Bsp Led.
*/

/*
 * Includes
 * ~~~~~~~~
 */

//#include "linux/khco_led_api.h"
//#include "../drivers/char/led/led_local.h"
//#include <include/api_inc/khco_led_api.h>
//#include <include/api_inc/led_local.h>
/** to enum the leds */
typedef enum _BOARD_LED_NAME
{   
/**< --dimm. Generic part for LB-mini */
	kLedPower,
	kLedInternet_SynchroLine,
	kLedInternetRed = kLedInternet_SynchroLine, /* Akka(S.VIE), 2011-10-21 */
	kLedInternet_DataConnectivity,
	kLedInternetGreen = kLedInternet_DataConnectivity, /* Akka(S.VIE), 2011-10-21 */
	kLedVoip1,
	kLedVoip=kLedVoip1, /* Akka(S.VIE), 2011-10-21 */

	/* Akka(S.VIE), 2011-10-21: Disabled "kLedVoip2" because it mismatches with redundant SaH-side header */
	//kLedVoip2,

	kLedLan,
	kLedWireless,
	kLedUpgrade,
/**> End of generic part for LB-mini */

/** --dimm  Board specific part */
/*	kLedEmac1Act,
	kLedEmac1Speed,
	kLedAdsl,
	kLedUsb,
	kLedHpna,
	kLedWanData,
	kLedPPP,
	kLedSelfTest,
*/

	/* Akka(S.VIE), 2011-12-01: New enumerated values for SaH's Red and Green "screen" LEDs.
   */
	kLedScreen_Green,
	kLedScreen_Red,

	kLedEnd		//NOTE: Insert the new led name before this one. this one should always be the last one!
} BOARD_LED_NAME;

/** to enum the states related to the leds */
typedef enum _BOARD_LED_STATE
{
/** turn off led */
	kLedStateOff,			
/** turn on led */
	kLedStateOn,			
} BOARD_LED_STATE;

/*
 * Functions
 * ~~~~~~~~~
 */

/** Set Led state. */
int kSysLedCtrl(	BOARD_LED_NAME 	_led,
				BOARD_LED_STATE	_state);

#if (defined HALBSP_PERGPIO_PROCENTRY)

/* Akka(S.VIE), 2011-12-01: Per-LED proc entries.
 */
int bsp_led_proc_initialize(void);
void bsp_led_proc_release(void);

#endif /* HALBSP_PERGPIO_PROCENTRY */

#endif

// vim:ts=5:
