/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_NOTIFY_H__
#define __BSP_NOTIFY_H__

/**
 * \file bsp_notify.h Bsp Notify description.
 *
 * This file allow to describe Bsp Notify.
 */

/*
 * Typedefs
 * ~~~~~~~~
 */

/**
 * \name Enum typedefs.
 */
/*@{*/
/** Typedef on enum bsp_notify_evt_enu. */
typedef enum bsp_notify_evt_enu		bsp_notify_evt_e;
/*@}*/

/*
 * Enums
 * ~~~~~
 */

/** SysCtl Sagem. */
enum bsp_notify_evt_enu {
	/** Voice module down. */
	BSP_Notify_evt_voice_module_down,

	/** Voice module up. */
	BSP_Notify_evt_voice_module_up,

	/** Adsl Link down. */
	BSP_Notify_evt_adsl_link_down,

	/** Adsl Link up. */
	BSP_Notify_evt_adsl_link_up,

	/** Relay Mode Adsl. */
	BSP_Notify_evt_relay_mode_adsl,

	/** Relay Mode Ftth. */
	BSP_Notify_evt_relay_mode_ftth,

	/** Relay Mode None. */
	BSP_Notify_evt_relay_mode_none,

	/** Need reset gpio slic. */
	BSP_Notify_evt_need_reset_gpio_slic,

	/** Need reset gpio usb. */
	BSP_Notify_evt_need_reset_gpio_usb,

	/** Need reset gpio lan. */
	BSP_Notify_evt_need_reset_gpio_lan,

	/** Max */
	BSP_Notify_evt_max,
};

/*
 * Functions
 * ~~~~~~~~~~
 */

/** Notify Evt. */
int bsp_notify_evt(	bsp_notify_evt_e	_event);

#endif

// vim:ts=5:
