/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_PERMPARAM_H__
#define __BSP_PERMPARAM_H__

/**
 * \file bsp_permParam.h Bsp Perm param description.
 *
 * This file allow to describe Bsp Get Get_permParam.
*/

/*
 * Includes
 * ~~~~~~~~
 */

#ifdef __KERNEL__
#include <asm/types.h>
#else
#include <stdint.h>
#endif

#include "bsp_common.h"

/*
 * Defines
 * ~~~~~~~
 */

/** Magic PP. */
#define BSP_MAGIC_PERMPARAM							0xffb76e2a

/** \name Perm Param All defined.
 */
/*@{*/
/** Type */
#define BSP_TYPE_PERMPARAM_ALL						struct bsp_permParam_str
/** Size. */
#define BSP_SIZE_PERMPARAM_ALL						sizeof(BSP_TYPE_PERMPARAM_ALL)
/*@}*/

/** \name Perm Param Version defined.
 */
/*@{*/
/** Type */
#define BSP_TYPE_PERMPARAM_VERSION						typeof(((pBsp_permParam_s)(0))->pp_version)
/** Size. */
#define BSP_SIZE_PERMPARAM_VERSION						sizeof(BSP_TYPE_PERMPARAM_VERSION)
/*@}*/

/** Perm Param serialNumber.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_SERIAL_NUMBER				typeof(((pBsp_permParam_s)(0))->serial_number)
/** Size. */
#define BSP_SIZE_PERMPARAM_SERIAL_NUMBER				sizeof(BSP_TYPE_PERMPARAM_SERIAL_NUMBER)
/*@}*/

/** Perm Param Sagem Product Id.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_SAGEM_PRODUCT_ID				typeof(((pBsp_permParam_s)(0))->s_product_id)
/** Size. */
#define BSP_SIZE_PERMPARAM_SAGEM_PRODUCT_ID				sizeof(BSP_TYPE_PERMPARAM_SAGEM_PRODUCT_ID)
/*@}*/

/** Perm Param Sagem Hardware Version.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_SAGEM_HARDWARE_VERSION			typeof(((pBsp_permParam_s)(0))->s_hardware_version)
/** Size. */
#define BSP_SIZE_PERMPARAM_SAGEM_HARDWARE_VERSION			sizeof(BSP_TYPE_PERMPARAM_SAGEM_HARDWARE_VERSION)
/*@}*/

/** Perm Param Sagem Hardware Revision.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_SAGEM_HARDWARE_REVISION		typeof(((pBsp_permParam_s)(0))->s_hardware_revision)
/** Size. */
#define BSP_SIZE_PERMPARAM_SAGEM_HARDWARE_REVISION		sizeof(BSP_TYPE_PERMPARAM_SAGEM_HARDWARE_REVISION)
/*@}*/

/** Perm Param Custumer Product Id.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_CUSTOMER_PRODUCT_ID			typeof(((pBsp_permParam_s)(0))->c_product_id)
/** Size. */
#define BSP_SIZE_PERMPARAM_CUSTOMER_PRODUCT_ID			sizeof(BSP_TYPE_PERMPARAM_CUSTOMER_PRODUCT_ID)
/*@}*/

/** Perm Param Customer Hardware Version.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_CUSTOMER_HARDWARE_VERSION		typeof(((pBsp_permParam_s)(0))->c_hardware_version)
/** Size. */
#define BSP_SIZE_PERMPARAM_CUSTOMER_HARDWARE_VERSION		sizeof(BSP_TYPE_PERMPARAM_CUSTOMER_HARDWARE_VERSION)
/*@}*/

/** Perm Param Customer Hardware Revision.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_CUSTOMER_HARDWARE_REVISION		typeof(((pBsp_permParam_s)(0))->c_hardware_revision)
/** Size. */
#define BSP_SIZE_PERMPARAM_CUSTOMER_HARDWARE_REVISION		sizeof(BSP_TYPE_PERMPARAM_CUSTOMER_HARDWARE_REVISION)
/*@}*/

/** Perm Param Ram Size.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_RAM_SIZE					typeof((*((pBsp_permParam_s)(0))).ram_size)
/** Size. */
#define BSP_SIZE_PERMPARAM_RAM_SIZE					sizeof(BSP_TYPE_PERMPARAM_RAM_SIZE)
/*@}*/

/** Perm Param Flash Size.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_FLASH_SIZE					typeof((*((pBsp_permParam_s)(0))).flash_size)
/** Size. */
#define BSP_SIZE_PERMPARAM_FLASH_SIZE					sizeof(BSP_TYPE_PERMPARAM_FLASH_SIZE)
/*@}*/

/** Size Perm Param Firmware version. */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_FIRMWARE_VERSION				typeof(((pBsp_permParam_s)(0))->fmw_version)
/** Size. */
#define BSP_SIZE_PERMPARAM_FIRMWARE_VERSION				sizeof(BSP_TYPE_PERMPARAM_FIRMWARE_VERSION)
/*@}*/

/** Perm Param lan base mac address.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_LAN_BASE_MAC_ADDRESS			typeof(((pBsp_permParam_s)(0))->lan_base_mac_address)
/** Size. */
#define BSP_SIZE_PERMPARAM_LAN_BASE_MAC_ADDRESS			sizeof(BSP_TYPE_PERMPARAM_LAN_BASE_MAC_ADDRESS)
/*@}*/

/** Perm Param lan mac address range.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_LAN_MAC_ADDRESS_RANGE			typeof((*((pBsp_permParam_s)(0))).lan_mac_address_range)
/** Size. */
#define BSP_SIZE_PERMPARAM_LAN_MAC_ADDRESS_RANGE			sizeof(BSP_TYPE_PERMPARAM_LAN_MAC_ADDRESS_RANGE)
/*@}*/

/** Size Perm Param wan base mac address.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WAN_BASE_MAC_ADDRESS			typeof(((pBsp_permParam_s)(0))->wan_base_mac_address)
/** Size. */
#define BSP_SIZE_PERMPARAM_WAN_BASE_MAC_ADDRESS			sizeof(BSP_TYPE_PERMPARAM_WAN_BASE_MAC_ADDRESS)
/*@}*/

/** Perm Param wan mac address range.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WAN_MAC_ADDRESS_RANGE			typeof((*((pBsp_permParam_s)(0))).wan_mac_address_range)
/** Size. */
#define BSP_SIZE_PERMPARAM_WAN_MAC_ADDRESS_RANGE			sizeof(BSP_TYPE_PERMPARAM_WAN_MAC_ADDRESS_RANGE)
/*@}*/

/** Size Perm Param usb mac address.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_USB_MAC						typeof(((pBsp_permParam_s)(0))->usb_mac)
/** Size. */
#define BSP_SIZE_PERMPARAM_USB_MAC						sizeof(BSP_TYPE_PERMPARAM_USB_MAC)
/*@}*/

/** Perm Param wifi SSID 1.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WIFI_SSID_1					typeof(((pBsp_permParam_s)(0))->wifi_ssid1)
/** Size. */
#define BSP_SIZE_PERMPARAM_WIFI_SSID_1					sizeof(BSP_TYPE_PERMPARAM_WIFI_SSID_1)
/*@}*/

/** Perm Param wifi Mac Address 1.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WIFI_MAC_ADDRESS_1			typeof(((pBsp_permParam_s)(0))->wifi_mac1)
/** Size Perm Param wifi Mac Address 1. */
#define BSP_SIZE_PERMPARAM_WIFI_MAC_ADDRESS_1			sizeof(BSP_TYPE_PERMPARAM_WIFI_MAC_ADDRESS_1)
/*@}*/

/** Perm Param wifi SSID 2.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WIFI_SSID_2					typeof(((pBsp_permParam_s)(0))->wifi_ssid2)
/** Size. */
#define BSP_SIZE_PERMPARAM_WIFI_SSID_2					sizeof(BSP_TYPE_PERMPARAM_WIFI_SSID_2)
/*@}*/

/** Perm Param wifi Mac Address 1.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WIFI_MAC_ADDRESS_2			typeof(((pBsp_permParam_s)(0))->wifi_mac2)
/** Size Perm Param wifi Mac Address 1. */
#define BSP_SIZE_PERMPARAM_WIFI_MAC_ADDRESS_2			sizeof(BSP_TYPE_PERMPARAM_WIFI_MAC_ADDRESS_2)
/*@}*/

/** Perm Param Manufacturer.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_MANUFACTURER					typeof(((pBsp_permParam_s)(0))->manufacturer)
/** Size. */
#define BSP_SIZE_PERMPARAM_MANUFACTURER					sizeof(BSP_TYPE_PERMPARAM_MANUFACTURER)
/*@}*/

/** Perm Param Manufacturer 3 first bytes og base_mac_address.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_MANUFACTURER_OUI				typeof(((pBsp_permParam_s)(0))->manufacturer_oui)
/** Size. */
#define BSP_SIZE_PERMPARAM_MANUFACTURER_OUI				sizeof(BSP_TYPE_PERMPARAM_MANUFACTURER_OUI)
/*@}*/

/** Perm Param Manufacturer url.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_MANUFACTURER_URL				typeof(((pBsp_permParam_s)(0))->manufacturer_url)
/** Size. */
#define BSP_SIZE_PERMPARAM_MANUFACTURER_URL				sizeof(BSP_TYPE_PERMPARAM_MANUFACTURER_URL)
/*@}*/

/** Perm Param Commercial Country.
 */
/*@{*/
/** Type */
#define BSP_TYPE_PERMPARAM_COUNTRY_CODE					typeof(((pBsp_permParam_s)(0))->country_code)
/** Size */
#define BSP_SIZE_PERMPARAM_COUNTRY_CODE					sizeof(BSP_TYPE_PERMPARAM_COUNTRY_CODE)
/*@}*/

/** Perm Param Wifi Key 1.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WIFI_KEY_1					typeof(((pBsp_permParam_s)(0))->wifi_key1)
/** Size. */
#define BSP_SIZE_PERMPARAM_WIFI_KEY_1					sizeof(BSP_TYPE_PERMPARAM_WIFI_KEY_1)
/*@}*/

/** Perm Param Wifi Key 2.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_WIFI_KEY_2					typeof(((pBsp_permParam_s)(0))->wifi_key2)
/** Size. */
#define BSP_SIZE_PERMPARAM_WIFI_KEY_2					sizeof(BSP_TYPE_PERMPARAM_WIFI_KEY_2)
/*@}*/

/** Perm Param H235 Key.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_H235_KEY					typeof(((pBsp_permParam_s)(0))->h235_key)
/** Size. */
#define BSP_SIZE_PERMPARAM_H235_KEY					sizeof(BSP_TYPE_PERMPARAM_H235_KEY)
/*@}*/

/** Perm Param Dsa Key used to sign APP2.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_PUBLIC_DSA_SYST				typeof(((pBsp_permParam_s)(0))->public_dsa_syst)
/** Size. */
#define BSP_SIZE_PERMPARAM_PUBLIC_DSA_SYST				sizeof(BSP_TYPE_PERMPARAM_PUBLIC_DSA_SYST)
/*@}*/

/** Perm Param Dsa Key used to sign APP1.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_PUBLIC_DSA_RESC				typeof(((pBsp_permParam_s)(0))->public_dsa_resc)
/** Size. */
#define BSP_SIZE_PERMPARAM_PUBLIC_DSA_RESC				sizeof(BSP_TYPE_PERMPARAM_PUBLIC_DSA_RESC)
/*@}*/

/** Perm Param Private Dsa Key.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_PRIVATE_KEY					typeof(((pBsp_permParam_s)(0))->private_key)
/** Size. */
#define BSP_SIZE_PERMPARAM_PRIVATE_KEY					sizeof(BSP_TYPE_PERMPARAM_PRIVATE_KEY)
/*@}*/

/** Perm Param Certificate.
*/
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_CERTIFICATE					typeof(((pBsp_permParam_s)(0))->certificate)
/** Size. */
#define BSP_SIZE_PERMPARAM_CERTIFICATE					sizeof(BSP_TYPE_PERMPARAM_CERTIFICATE)
/*@}*/

/** Perm Param Dsa.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_DSA						typeof((*((pBsp_permParam_s)(0))).dsa)
/** Size. */
#define BSP_SIZE_PERMPARAM_DSA						sizeof(BSP_TYPE_PERMPARAM_DSA)
/*@}*/

/** Perm Param Vendor Info 1.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_1				typeof(((pBsp_permParam_s)(0))->vendor_info1)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_1				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_1)
/*@}*/

/** Perm Param Vendor Info 2.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_2				typeof(((pBsp_permParam_s)(0))->vendor_info2)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_2				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_2)
/*@}*/

/** Perm Param Vendor Info 3.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_3				typeof(((pBsp_permParam_s)(0))->vendor_info3)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_3				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_3)
/*@}*/

/** Perm Param Vendor Info 4.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_4				typeof(((pBsp_permParam_s)(0))->vendor_info4)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_4				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_4)
/*@}*/

/** Perm Param Vendor Info 5.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_5				typeof(((pBsp_permParam_s)(0))->vendor_info5)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_5				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_5)
/*@}*/

/** Perm Param Vendor Info 6.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_6				typeof(((pBsp_permParam_s)(0))->vendor_info6)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_6				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_6)
/*@}*/

/** Perm Param Vendor Info 7.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_7				typeof(((pBsp_permParam_s)(0))->vendor_info7)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_7				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_7)
/*@}*/

/** Perm Param Vendor Info 8.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_8				typeof(((pBsp_permParam_s)(0))->vendor_info8)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_8				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_8)
/*@}*/

/** Perm Param Vendor Info 9.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_9				typeof(((pBsp_permParam_s)(0))->vendor_info9)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_9				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_9)
/*@}*/

/** Perm Param Vendor Info 10.
 */
/*@{*/
/** Type. */
#define BSP_TYPE_PERMPARAM_VENDOR_INFO_10				typeof(((pBsp_permParam_s)(0))->vendor_info10)
/** Size. */
#define BSP_SIZE_PERMPARAM_VENDOR_INFO_10				sizeof(BSP_TYPE_PERMPARAM_VENDOR_INFO_10)
/*@}*/

/*
 * Enums
 * ~~~~~
 */

/** Pp to board. */
enum bsp_pp2board_enu {
	/** Unknown.
	 *	\note Don't touch it place.
	 */
	BSP_Pp2board_unknown,

	/** Livebox 2. */
	BSP_Pp2board_lb_2,

	/** Livebox 2 Mini. */
	BSP_Pp2board_lb_2_mini,

	/** Livebox FTTHv2. */
	BSP_Pp2board_lb_ftthv2,

	/** Livebox FTTH v2. */
	BSP_Pp2board_lb_ftth_v2_1,

	/** Livebox FTTH v2. */
	BSP_Pp2board_lb_ftth_v2_2,

	/** Fast3504. */
	BSP_Pp2board_fast_3504,

	/** Lbv2. */
	BSP_Pp2board_lb2,

	/** 3764. */
	BSP_Pp2board_3764,

	/** TDC 180. */
	BSP_Pp2board_TDC_180,

	/** Bbox. */
	BSP_Pp2board_Bbox,

	/** Livebox ProV3 vox185. */
	BSP_Pp2board_lbv3,
	
	/** TDC HGW3 vx183. */
	BSP_Pp2board_TDC_183,

	/** Livebox ProV3 vox185.  v2*/
	BSP_Pp2board_lbv3_v2,

	/** Livebox 2.8 hardware "v0" (aka "P1" at FT's) */
	BSP_Pp2board_lbv28_v0,

	/** Livebox 2.8 hardware "v1" (aka "P2" at FT's) */
	BSP_Pp2board_lbv28_v1,

	/** Max. */
	BSP_Pp2board_max,
};

/** Pp info. */
enum bsp_pp_info_enu {
	/** PP Info Sagem Product Id. */
	BSP_Pp_info_sagem_product_id,

	/** PP Info Sagem Hardware Version. */
	BSP_Pp_info_sagem_hardware_version,

	/** PP Info Sagem Hardware Revision. */
	BSP_Pp_info_sagem_hardware_revision,

	/** PP Info Costumer Product Id. */
	BSP_Pp_info_customer_product_id,

	/** PP Info Customer Hardware Version. */
	BSP_Pp_info_customer_hardware_version,

	/** PP Info Customer Hardware Revision. */
	BSP_Pp_info_customer_hardware_revision,

	/** PP Info Max. */
	BSP_Pp_info_max,
};

/** Permament Parameter. */
enum bsp_get_permParam_enu {
	/** Perm Param Get All. */
	BSP_Get_permParam_all,

	/** Perm Param Get Version. */
	BSP_Get_permParam_version,

	/** Perm Param Get serialNumber. */
	BSP_Get_permParam_serial_number,

	/** Perm Param Get Sagem Product Id. */
	BSP_Get_permParam_sagem_product_id,

	/** Perm Param Get Sagem Hardware Version. */
	BSP_Get_permParam_sagem_hardware_version,

	/** Perm Param Get Sagem Hardware Revision. */
	BSP_Get_permParam_sagem_hardware_revision,

	/** Perm Param Get Costumer Product Id. */
	BSP_Get_permParam_customer_product_id,

	/** Perm Param Get Customer Hardware Version. */
	BSP_Get_permParam_customer_hardware_version,

	/** Perm Param Get Customer Hardware Revision. */
	BSP_Get_permParam_customer_hardware_revision,

	/** Perm Param Get Ram Size. */
	BSP_Get_permParam_ram_size,

	/** Perm Param Get Flash Size. */
	BSP_Get_permParam_flash_size,

	/** Perm Param Get Firmware Version. */
	BSP_Get_permParam_firmware_version,

	/** Perm Param Get Lan Base Mac Address. */
	BSP_Get_permParam_lan_base_mac_address,

	/** Perm Param Get Lan Mac Address Range. */
	BSP_Get_permParam_lan_mac_address_range,

	/** Perm Param Get Wan Base Mac Address. */
	BSP_Get_permParam_wan_base_mac_address,

	/** Perm Param Get Wan Mac Address Range. */
	BSP_Get_permParam_wan_mac_address_range,

	/** Perm Param Get Usb Mac Address. */
	BSP_Get_permParam_usb_mac,

	/** Perm Param Get Wifi Mac Address number 1. */
	BSP_Get_permParam_wifi_mac_address_1,

	/** Perm Param Get Wifi SSID number 1. */
	BSP_Get_permParam_wifi_ssid_1,

	/** Perm Param Get Wifi Mac Address number 2. */
	BSP_Get_permParam_wifi_mac_address_2,

	/** Perm Param Get Wifi SSID number 2. */
	BSP_Get_permParam_wifi_ssid_2,

	/** Perm Param Get Manufacturer. */
	BSP_Get_permParam_manufacturer,

	/** Perm Param Get Manufacturer Base Mac Address. */
	BSP_Get_permParam_manufacturer_oui,

	/** Perm Param Get Manufacturer Url. */
	BSP_Get_permParam_manufacturer_url,

	/** Perm Param Get Commercialize Country. */
	BSP_Get_permParam_country_code,

	/** Perm Param Get Wifi Key Number 1. */
	BSP_Get_permParam_wifi_key_1,

	/** Perm Param Get Wifi Key Number 2. */
	BSP_Get_permParam_wifi_key_2,

	/** Perm Param Get H235 Key. */
	BSP_Get_permParam_h235_key,

	/** Perm Param Get Public Dsa System. */
	BSP_Get_permParam_public_dsa_syst,

	/** Perm Param Get Public Dsa Rescue. */
	BSP_Get_permParam_public_dsa_resc,

	/** Perm Param Get Private Dsa Key. */
	BSP_Get_permParam_private_key,

	/** Perm Param Get Certificate. */
	BSP_Get_permParam_certificate,

	/** Perm Param Get Dsa. */
	BSP_Get_permParam_dsa,

	/** Perm Param Get Vendor Info Number 1. */
	BSP_Get_permParam_vendor_info_1,

	/** Perm Param Get Vendor Info Number 2. */
	BSP_Get_permParam_vendor_info_2,

	/** Perm Param Get Vendor Info Number 3. */
	BSP_Get_permParam_vendor_info_3,

	/** Perm Param Get Vendor Info Number 4. */
	BSP_Get_permParam_vendor_info_4,

	/** Perm Param Get Vendor Info Number 5. */
	BSP_Get_permParam_vendor_info_5,

	/** Perm Param Get Vendor Info Number 6. */
	BSP_Get_permParam_vendor_info_6,

	/** Perm Param Get Vendor Info Number 7. */
	BSP_Get_permParam_vendor_info_7,

	/** Perm Param Get Vendor Info Number 8. */
	BSP_Get_permParam_vendor_info_8,

	/** Perm Param Get Vendor Info Number 9. */
	BSP_Get_permParam_vendor_info_9,

	/** Perm Param Get Vendor Info Number 10. */
	BSP_Get_permParam_vendor_info_10,

	/** Get_permParam Max. */
	BSP_Get_permParam_max,
};

/*
 * Structs
 * ~~~~~~~
 */

/*
 * Typedefs
 * ~~~~~~~~
 */

/** \name Enums.
 */
/*@{*/
/** \link bsp_pp2board_enu bsp_pp2board enum \endlink typedef. */
typedef enum bsp_pp2board_enu				bsp_pp2board_e;
/** \link bsp_pp_info_enu bsp_pp_info enum \endlink typedef. */
typedef enum bsp_pp_info_enu 				bsp_pp_info_e;
/*@}*/

/** \name bsp_permParam struct Typedefs.
 */
/*@{*/
/** \link bsp_permParam_str bsp_permParam struct \endlink typedef. */
typedef struct bsp_permParam_str			bsp_permParam_s;
/** \link bsp_permParam_str bsp_permParam struct \endlink pointer typedef. */
typedef struct bsp_permParam_str			*pBsp_permParam_s;
/*@}*/


/*
 * Functions
 * ~~~~~~~~~
 */

#ifdef __KERNEL__
/** Init permParam. */
int bsp_init_permParam(void);

/** Get Get_permParam. */
void *bsp_get_permParam(						enum bsp_get_permParam_enu	_getGet_permParam);

/** Get Perm Param All. */
void *bsp_get_permParam_all(					pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param version. */
void *bsp_get_permParam_version(				pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param serial number. */
char *bsp_get_permParam_serialNumber(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Sagem Product Id. */
char *bsp_get_permParam_sagemProductId(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Sagem Hardware Version. */
char *bsp_get_permParam_sagemHardwareVersion(	pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Sagem Hardware Revision. */
char *bsp_get_permParam_sagemHardwareRevision(	pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Customer Product Id. */
char *bsp_get_permParam_customerProductId(		pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Customer Hardware Version. */
char *bsp_get_permParam_customerHardwareVersion(	pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Customer Hardware Revision. */
char *bsp_get_permParam_customerHardwareRevision(	pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Ram Size. */
__u32 *bsp_get_permParam_ramSize(				pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Flash Size. */
__u32 *bsp_get_permParam_flashSize(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Firmware Version. */
char *bsp_get_permParam_firmVersion(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Lan Base Mac Addr. */
__u8 *bsp_get_permParam_lanBaseMacAddr(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Lan Mac Addr Range. */
__u16 *bsp_get_permParam_lanMacAddrRange(		pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wan Base Mac Addr. */
__u8 *bsp_get_permParam_wanBaseMacAddr(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wan Mac Addr Range. */
__u16 *bsp_get_permParam_wanMacAddrRange(		pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Usb Mac Addr. */
__u8 *bsp_get_permParam_usbMacAddr(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wifi Mac1 Addr. */
__u8 *bsp_get_permParam_wifiMac1Addr(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wifi ssid1. */
char *bsp_get_permParam_wifiSsid1(				pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wifi Mac2 Addr. */
__u8 *bsp_get_permParam_wifiMac2Addr(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wifi ssid2. */
char *bsp_get_permParam_wifiSsid2(				pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Manufacturer. */
char *bsp_get_permParam_manufacturer(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Manufacturer Base Mac Addr. */
__u8 *bsp_get_permParam_manufacturerBaseMacAddr(	pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Manufacturer Url. */
char *bsp_get_permParam_manufacturerUrl(		pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Commercialization Country. */
char *bsp_get_permParam_comCountry(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wifi Key1. */
char *bsp_get_permParam_wifiKey1(				pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Wifi Key2. */
char *bsp_get_permParam_wifiKey2(				pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param H235 Key. */
char *bsp_get_permParam_h235Key(				pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Public Dsa Syst. */
__u8 *bsp_get_permParam_publicDsaSyst(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Public Dsa Resc. */
__u8 *bsp_get_permParam_publicDsaResc(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Private Dsa Key. */
__u8 *bsp_get_permParam_privateDsaKey(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Certificate. */
__u8 *bsp_get_permParam_certificate(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Dsa. */
__u32 *bsp_get_permParam_dsa(					pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info1. */
char *bsp_get_permParam_vendorInfo1(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info2. */
char *bsp_get_permParam_vendorInfo2(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info3. */
char *bsp_get_permParam_vendorInfo3(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info4. */
char *bsp_get_permParam_vendorInfo4(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info5. */
char *bsp_get_permParam_vendorInfo5(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info6. */
char *bsp_get_permParam_vendorInfo6(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info7. */
char *bsp_get_permParam_vendorInfo7(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info8. */
char *bsp_get_permParam_vendorInfo8(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info9. */
char *bsp_get_permParam_vendorInfo9(			pBsp_permParam_s			_pGet_permParam);

/** Get Perm Param Vendor Info10. */
char *bsp_get_permParam_vendorInfo10(			pBsp_permParam_s			_pGet_permParam);

#endif

#endif

// vim:ts=5:
