/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

#ifndef __BSP_SYSCTL_H__
#define __BSP_SYSCTL_H__

/**
 * \file bsp_sysctl.h Bsp Sysctl description.
 *
 * This file allow to describe Bsp Syctl.
*/

/*
 * Include
 * ~~~~~~~
 */

#include <linux/sysctl.h>

/*
 * Enums
 * ~~~~~
 */

/** SysCtl Sagem. */
enum bsp_sysCtl_sagem_enu {
	/** Unknown. */
	BSP_SysCtl_sagem = 0x03022009
};

/** SysCtl Sagem List. */
enum bsp_sysCtl_sagem_list_enu {
	/** Null. */
	BSP_SysCtl_sagem_list_null,
	/** Type Firmware. */
	BSP_SysCtl_sagem_list_type_firmware,
	/** Type Board. */
	BSP_SysCtl_sagem_list_type_board,
	/** Boot. */
	BSP_SysCtl_sagem_list_boot,
	/** Relay. */
	BSP_SysCtl_sagem_list_relay,
	/** Led. */
	BSP_SysCtl_sagem_list_led,
	/** But. */
	BSP_SysCtl_sagem_list_but,
	/** Gpio. */
	BSP_SysCtl_sagem_list_gpio,
	/** Max. */
	BSP_SysCtl_sagem_list_max,
};

/** SysCtl Sagem List Boot. */
enum bsp_sysCtl_sagem_list_boot_enu {
	/** Null. */
	BSP_SysCtl_sagem_list_boot_null,
	/** Recovery Force. */
	BSP_SysCtl_sagem_list_boot_recovery_force,
	/** Max. */
	BSP_SysCtl_sagem_list_boot_max,
};

/** SysCtl Sagem List Relay. */
enum bsp_sysCtl_sagem_list_relay_enu {
	/** Null. */
	BSP_SysCtl_sagem_list_relay_null,
	/** Force all fxs relay. */
	BSP_SysCtl_sagem_list_relay_force_all_fxs,
	/** Mode. */
	BSP_SysCtl_sagem_list_relay_mode,
	/** Maps. */
	BSP_SysCtl_sagem_list_relay_maps,
	/** Max. */
	BSP_SysCtl_sagem_list_relay_max,
};

/** SysCtl Sagem List led. */
enum bsp_sysCtl_sagem_list_led_enu {
	/** Null. */
	BSP_SysCtl_sagem_list_led_null,
	/** Maps. */
	BSP_SysCtl_sagem_list_led_maps,
	/** Max. */
	BSP_SysCtl_sagem_list_led_max,
};

/** SysCtl Sagem List but. */
enum bsp_sysCtl_sagem_list_but_enu {
	/** Null. */
	BSP_SysCtl_sagem_list_but_null,
	/** Maps. */
	BSP_SysCtl_sagem_list_but_maps,
	/** Max. */
	BSP_SysCtl_sagem_list_but_max,
};

/** SysCtl Sagem List gpio. */
enum bsp_sysCtl_sagem_list_gpio_enu {
	/** Null. */
	BSP_SysCtl_sagem_list_gpio_null,
	/** Maps. */
	BSP_SysCtl_sagem_list_gpio_maps,
	/** Max. */
	BSP_SysCtl_sagem_list_gpio_max,
};

#endif

// vim:ts=5:
