/*
 * ============================================================================
 *
 * Copyright : (c) 2005 SAGEM SA - Site Velizy - URD2
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 * ============================================================================
 */

/**
 * \file bsp_permParam.c Bsp Permanent Parameter format description.
 *
 * This file allow to describe Bsp Permanent Parameter format.
*/

/*
 * Includes
 * ~~~~~~~~
 */
#include "bsp_pri.h"

/*
 * Functions
 * ~~~~~~~~~
 */
int bsp_read_file(char *name, void* buffer)
{
   long bcount;
   mm_segment_t fs;
   struct file *fp;
   long fsize = 0;

   fs = get_fs();
   set_fs(KERNEL_DS);
   fp = filp_open(name, O_RDONLY, 0);

   if (IS_ERR(fp))
   {
	 set_fs(fs);
	 HALBSP_ERROR("%s File opening did not success", name);
	 return -1;
   }

   fsize = fp->f_op->llseek(fp, 0, 2);
   fp->f_op->llseek(fp, 0, 0);
   bcount = kernel_read(fp, 0, buffer, fsize);
   filp_close(fp, NULL);
   set_fs(fs);

   return 0;
}

// vim:ts=5:
