include $(STAGINGDIR)/components.config

ifeq ($(notdir $(CC)),gcc)
  FREETYPE_CONFIGURATION:=
else
  FREETYPE_CONFIGURATION:=--host=mips-linux --prefix=/ --build=i686
endif

FREETYPE-VERSION := freetype-2.4.6

all: freetype-all

install :
	@echo "Installing to: " $(STAGINGDIR)
	$(MAKE) -C $(FREETYPE-VERSION) install DESTDIR=$(STAGINGDIR)
	$(INSTALL) -d $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 0755 freetype2.pc $(PKG_CONFIG_LIBDIR)/freetype2.pc

release:
	@echo "Releasing to: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 0644 $(STAGINGDIR)/lib/libfreetype.so.6 $(ROOT_FS_DIR)/lib
	(cd $(ROOT_FS_DIR)/lib; ln -sf libfreetype.so.6 libfreetype.so.6.7.1)

clean:
	if [ -e $(FREETYPE-VERSION)/Makefile ]; then $(MAKE) -C $(FREETYPE-VERSION) distclean; fi;

freetype-all:
	cd $(FREETYPE-VERSION) ; ./configure $(FREETYPE_CONFIGURATION)
	$(MAKE) -C $(FREETYPE-VERSION) all


.PHONY: all install release clean
