export CFLAGS += -g -I$(STAGINGDIR)/include -I$(STAGINGDIR)/include/expat
export LDFLAGS += -L$(STAGINGDIR)/lib

ifneq ($(notdir $(CC)),gcc)
  HOST=--host=mips-linux
endif

SONAME=libscew.so.1.0.2
LINKS=libscew.so.1 libscew.so

CP?=cp
INSTALL?=install
STRIP?=strip

all: ./build/Makefile
	$(MAKE) -C ./build

./build/Makefile: configure Component.mk
	mkdir -p ./build
	cd ./build && ../configure $(HOST) --prefix= --build=i386-linux --enable-shared --disable-static --with-gnu-ld --disable-threads \
		CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		CC="$(CC)" STRIP="$(STRIP)" INSTALL="$(INSTALL)"

clean:
	if [ -d ./build ] ; then rm -rf ./build ; fi

install:
	@echo "Installing to: " $(STAGINGDIR)
	$(MAKE) -C ./build DESTDIR=$(STAGINGDIR) install

release:
	@echo "Releasing to: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 0644 $(STAGINGDIR)/lib/$(SONAME) $(ROOT_FS_DIR)/lib
	$(CP) -d $(addprefix $(STAGINGDIR)/lib/,$(LINKS)) $(ROOT_FS_DIR)/lib

.PHONY: all clean install release

