include $(STAGINGDIR)/components.config

SDL_TTF_CONFIGURATION := --with-sdl-prefix=$(STAGINGDIR) --with-freetype-prefix=$(STAGINGDIR)

ifeq ($(notdir $(CC)),gcc)
  SDL-TTFL_CONFIGURATION_CFLAGS:=-ggdb3 -O0
else
  SDL-TTFL_CONFIGURATION_CFLAGS:= -g -O2
	SDL_TTF_CONFIGURATION += --host=mips-linux --prefix=/ --build=i686 --disable-sdltest --without-x
endif

SDL-TTFL_CONFIGURATION_CFLAGS += -I$(STAGINGDIR)/include/freetype2 -I$(STAGINGDIR)/include/freetype2/freetype -I$(STAGINGDIR)/include/SDL -L$(STAGINGDIR)/lib


SDL_TTF-VERSION := SDL_ttf-2.0.10

all: sdl-ttf-all

install :
	@echo "Installing to: " $(STAGINGDIR)
	$(MAKE) -C $(SDL_TTF-VERSION) install DESTDIR=$(STAGINGDIR)
	$(INSTALL) -d $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 0755 SDL_ttf.pc $(PKG_CONFIG_LIBDIR)/

release:
	@echo "Releasing to: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 0644 $(STAGINGDIR)/lib/libSDL_ttf.so $(ROOT_FS_DIR)/lib
	(cd $(ROOT_FS_DIR)/lib; ln -sf libSDL_ttf.so libSDL_ttf-2.0.so.0)
	(cd $(ROOT_FS_DIR)/lib; ln -sf libSDL_ttf.so libSDL_ttf-2.0.so.0.10.0)

clean:
	if [ -e $(SDL_TTF-VERSION)/Makefile ]; then $(MAKE) -C $(SDL_TTF-VERSION) distclean; fi;
	rm -rf $(SDL_TTF-VERSION)/Makefile

sdl-ttf-all: $(SDL_TTF-VERSION)/Makefile
	$(MAKE) -C $(SDL_TTF-VERSION) all

$(SDL_TTF-VERSION)/Makefile:
	cd $(SDL_TTF-VERSION) ; \
	./configure $(SDL_TTF_CONFIGURATION) CFLAGS="$(SDL-TTFL_CONFIGURATION_CFLAGS)"


.PHONY: all install release clean
