class Libsqlite < Application

    @@name_lib       = "libsqlite"
    @@path_lib       = "#{$middleware_dir}/cm/#@@name_lib"
    @@path_lib_build = "#@@path_lib/build"

	TARGET = "#@@name_lib"

    def Libsqlite.make *args
		# Check if something has already been compiled and if so,
		# guess its type.
		if File.exists?("#@@path_lib_build/lib/#@@name_lib.so")
            if `file -L #@@path_lib_build/lib/#@@name_lib.so`.include? "Renesas"
				current_type	= "sh4"
			else	# Assume pc
				current_type	= "pc"
			end
		end

		puts "Libsqlite current binary type is #{current_type} / #{GeneralConf["project_arch"]}"

        # Libsqlite specific options 
        ENV["LIBSQLITE_PREFIX"] = "#@@path_lib_build"

		if GeneralConf["project_arch"] != current_type
			# Need to clean, since the binary type is different
			# from what we intend to use. 
            sh "make -C #@@path_lib -f Makefile.stb clean"
		end

		case GeneralConf["project_arch"]
		when "pc"
			ENV["LIBSQLITE_CC"]	         = "gcc"
			ENV["LIBSQLITE_STRIP"]	     = "strip"
		when "sh4"
			ENV["LIBSQLITE_CC"]	         = "sh4-linux-gcc"
			ENV["LIBSQLITE_STRIP"]	     = "sh4-linux-strip"
		end

        # Libsqlite Make
        sh "make -C #@@path_lib -f Makefile.stb all install"
        sh "cp #@@path_lib_build/lib/#@@name_lib.so #{$bin_dir}"
	end

	def Libsqlite.install *args
		sh "sudo cp -f #@@path_lib_build/lib/#@@name_lib.so #{$rootfs_dir}/usr/lib" 
	end

	def Libsqlite.img *args
		sh "sudo cp -f #@@path_lib_build/lib/#@@name_lib.so #{$flash_rootfs_dir_tmp}/lib" 
	end

	def Libsqlite.clean
		if File.exists?("#{$bin_dir}/#@@name_lib.so")
            sh "rm  #{$bin_dir}/#@@name_lib.so"
        end
        # Libsqlite specific options 
        ENV["LIBSQLITE_PREFIX"] = "#@@path_lib_build"
        # Libsqlite Make Clean
        sh "make -C #@@path_lib -f Makefile.stb clean"
	end
end
