# include components.config 
ifdef STAGINGDIR
include $(STAGINGDIR)/components.config
endif
PKG_CONFIG_LIBDIR ?= $(STAGINGDIR)/build/pkg-config

all:
	$(MAKE) -C src all

clean:
	$(MAKE) -C src clean

install:
	echo "INSTALL="
	$(INSTALL) -d $(STAGINGDIR)/include
	for FILE in $$(find include/yajl/ -type f); do \
		$(INSTALL) -p -m 0644 -D $${FILE} $(STAGINGDIR)/$${FILE} || exit 1; \
	done
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 0755 src/libyajl.so $(STAGINGDIR)/lib
	$(INSTALL) -D -m 0644 pkg-config.pc $(PKG_CONFIG_LIBDIR)/yajl.pc

release:
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 755 $(STAGINGDIR)/lib/libyajl.so $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libyajl.so

#doc:
#	doxygen src/YAJL.dxy
#	$(INSTALL) -d $(STAGINGDIR)/doc/pcb
#	for FILE in $$(find html -type f); do \
#		$(INSTALL) -m 0644 -D $${FILE} $(STAGINGDIR)/doc/pcb/$${FILE} || exit 1; \
#	done

#test: all
#	make -C test

.PHONY: all clean install release

