



all:
	@echo "###Configuring CUPS"
	ac_cv_search_getaddrinfo=no ./configure \
		--prefix=/usr \
		--host=mips-linux-uclibc \
		--build=i386-linux \
		--enable-browsing \
		--disable-openssl \
		--disable-tiff \
		--disable-threads \
		--disable-gssapi \
		--without-php \
		--without-perl \
		--without-python \
		--without-java \
		--with-cachedir=/tmp/cups  \
		--localstatedir=/var \
		--enable-raw-printing \
		--disable-gnutls \
		--disable-dbus \
		--with-printcap=/var/tmp/cups/printcap \
		--disable-debug \
		CFLAGS="-ffunction-sections -fdata-sections" \
		LDFLAGS="-Wl,--gc-sections"

	@echo "Building CUPS"
	make all

	
clean:
	@echo "###Cleaning CUPS"
	make clean

install:
	@echo "###Installing cups to " $(STAGINGDIR)
	make install
	
uninstall:
	@echo "###Installing cups to " $(STAGINGDIR)
	make uninstall

release:
	@echo "###Releasing cups to " $(ROOT_FS_DIR)
	make rel

.PHONY: clean all install uninstall release check
