#include "locale_dummy.h"
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <limits.h>
#include <stdint.h>
#include <assert.h>
#include <errno.h>
#include <ctype.h>
#include <stdio.h>

static struct lconv the_lconv;

static const char decpt[] = ".";

struct lconv *localeconv(void)
{
        register char *p = (char *)(&the_lconv);

        *((char **)p) = (char *) decpt;
        do {
                p += sizeof(char **);
                *((char **)p) = (char *) (decpt+1);
        } while (p < (char *) &the_lconv.negative_sign);

        p = (&the_lconv.int_frac_digits);
        do {
                *p = CHAR_MAX;
                ++p;
        } while (p <= &the_lconv.int_n_sign_posn);

        return &the_lconv;
}


static const char C_string[] = "C";

char *setlocale(int category, register const char *locale)
{
        return ( (((unsigned int)(category)) <= LC_ALL)
                         && ( (!locale)         /* Request for locale category string. */
                                  || (!*locale) /* Implementation-defined default is C. */
                                  || ((*locale == 'C') && !locale[1])
                                  || (!strcmp(locale, "POSIX"))) )
                ? (char *) C_string             /* Always in C/POSIX locale. */
                : NULL;
}


