CCOPT=-D_GNU_SOURCE -O2 -Wstrict-prototypes -Wall -g -I$(STAGINGDIR)/include
CFLAGS=$(CCOPT) $(GLIBCFIX) $(DEFINES) 
LDFLAGS=-L $(STAGINGDIR)/lib -lssl -lcrypto -ldl 

IPV4_TARGETS=tracepath ping clockdiff rdisc tftpd rarpd
IPV6_TARGETS=tracepath6 traceroute6 ping6
TARGETS=$(IPV4_TARGETS) $(IPV6_TARGETS)

all: $(TARGETS) Component.mk

tftpd: tftpd.o tftpsubs.o 

arping: arping.o
	$(CC) $(CFLAGS) -o $@ $<

ping: ping.o ping_common.o 

ping6: ping6.o ping_common.o 

#-lresolv -lcrypto 

ping.o ping6.o ping_common.o: ping_common.h 

tftpd.o tftpsubs.o: tftp.h

rdisc_srv: rdisc_srv.o 

rdisc_srv.o: rdisc.c
	$(CC) $(CFLAGS) -DRDISC_SERVER -o rdisc_srv.o rdisc.c


clean:
	@rm -f *.o $(TARGETS)

install:
	@echo " ##   Installing iptutils"
	$(INSTALL) -d $(STAGINGDIR)/usr/lib/iputils/
	$(INSTALL) -m 755 ping $(STAGINGDIR)/usr/lib/iputils
	$(INSTALL) -m 755 ping6 $(STAGINGDIR)/usr/lib/iputils
	$(INSTALL) -m 755 rarpd $(STAGINGDIR)/usr/lib/iputils
	$(INSTALL) -m 755 rdisc $(STAGINGDIR)/usr/lib/iputils
	$(INSTALL) -m 755 tftpd $(STAGINGDIR)/usr/lib/iputils
	$(INSTALL) -m 755 tracepath $(STAGINGDIR)/usr/lib/iputils
	$(INSTALL) -m 755 tracepath6 $(STAGINGDIR)/usr/lib/iputils
	$(INSTALL) -m 755 traceroute6 $(STAGINGDIR)/usr/lib/iputils

release:
	@echo " ##   Releasing iptutils"
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/lib/iputils/
	$(INSTALL) -m 755 ping $(ROOT_FS_DIR)/usr/lib/iputils/
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/ping
	$(INSTALL) -m 755 ping6 $(ROOT_FS_DIR)/usr/lib/iputils
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/ping6
	$(INSTALL) -m 755 rarpd $(ROOT_FS_DIR)/usr/lib/iputils/
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/rarpd
	$(INSTALL) -m 755 rdisc $(ROOT_FS_DIR)/usr/lib/iputils/
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/rdisc
	$(INSTALL) -m 755 tftpd $(ROOT_FS_DIR)/usr/lib/iputils/
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/tftpd
	$(INSTALL) -m 755 tracepath $(ROOT_FS_DIR)/usr/lib/iputils/
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/tracepath
	$(INSTALL) -m 755 tracepath6 $(ROOT_FS_DIR)/usr/lib/iputils/
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/tracepath6
	$(INSTALL) -m 755 traceroute6 $(ROOT_FS_DIR)/usr/lib/iputils/
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/iputils/traceroute6





