include $(STAGINGDIR)/components.config

#Q = @

ETCDIR=/etc_ro_fs/wifi-community

PROGRAM_NAME = l2tpd

OBJS = l2tpd.o pty.o misc.o control.o avp.o call.o network.o avpsend.o scheduler.o file.o aaa.o md5.o status.o
 
HEADERS = l2tp.h avp.h misc.h control.h call.h scheduler.h file.h aaa.h md5.h status.h

CFLAGS += -O2 -Wall -Wno-implicit -c -g -DIP_ALLOCATION -DSANITY -DLINUX


all: $(PROGRAM_NAME) 

$(OBJS): $(HEADERS) 

%.o: %.c 
	@echo " ##   Compiling $<"
	$(Q)$(CC) -c $(CFLAGS) -o $@ $<

$(PROGRAM_NAME): $(OBJS) 
	@echo " ##   Linking $@"
	$(Q)$(CC) -o $@ $(OBJS) $(LDFLAGS)

clean:
	@echo " ##   Cleaning $(PROGRAM_NAME)"
	$(Q)rm -f $(PROGRAM_NAME) *.o 

install: all
	@echo " ##   Installing /usr/sbin/$(PROGRAM_NAME)"
	$(Q)$(INSTALL) -d $(STAGINGDIR)/usr/sbin
	$(Q)$(INSTALL) -m 755 $(PROGRAM_NAME) $(STAGINGDIR)/usr/sbin

release: all
	@echo " ##   Releasing /usr/sbin/$(PROGRAM_NAME)"
	$(Q)$(INSTALL) -d $(RELEASEDIR)/usr/sbin
	$(Q)$(INSTALL) -m 755 $(PROGRAM_NAME) $(RELEASEDIR)/usr/sbin
	@echo " ##   Stripping $(PROGRAM_NAME)"
	$(Q)$(STRIP) $(RELEASEDIR)/usr/sbin/$(PROGRAM_NAME)
	$(Q)$(INSTALL) -d $(RELEASEDIR)$(ETCDIR)
	$(Q)$(INSTALL) -d $(RELEASEDIR)$(ETCDIR)/l2tp
	$(Q)$(INSTALL) -m 644 options.l2tpd.wifi-community $(RELEASEDIR)$(ETCDIR)/l2tp/options.l2tpd
	$(Q)$(INSTALL) -m 600 l2tpd.conf l2tp-secrets $(RELEASEDIR)$(ETCDIR)/l2tp/

.PHONY: clean all install release
