#!/bin/sh

unset  MTD_DEV
unset  MTD_ERASE_SIZE
unset  MTD_SIZE
export MTF_CMD=mtd_debug
export TMP_FILE=/tmp/mtd.erased



zero_file ()
{
    if [ -f $1  ]; then
      rm $1 
    fi

    touch  $1 
}
# $1 file_name, $2 file size, $3 

erase_all ()
{
    echo "erasing all the partition sectors "
    i=0
    while [  $i -lt ${NBRE_BLOCK}  ] ; do
        echo -n "."
        ${MTF_CMD} erase ${MTD_DEV} $(( ${i} * ${MTD_ERASE_SIZE} )) ${MTD_ERASE_SIZE} &>/dev/null
        let i=i+1
    done
    echo "done."

}

test_erase ()
{
    zero_file  ${TMP_FILE} 

    PAT="\xff\xff\xff\xff"
    PAT_64=$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT
    PAT_1024=$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64
    i=0
    while [ $i -lt  $(( ${MTD_ERASE_SIZE} /1024 )) ]; do
         printf $PAT_1024  >> ${TMP_FILE}
        let i=i+1
    done

    echo -n "checking if sector is erased"
    i=0
    while [  $i -lt ${NBRE_BLOCK}  ] ; do
        ${MTF_CMD} read ${MTD_DEV} $(( ${i} * ${MTD_ERASE_SIZE} )) ${MTD_ERASE_SIZE} /tmp/mtd_b_$i.dump &>/dev/null
        cmp   /tmp/mtd_b_$i.dump ${TMP_FILE} 
        if [ $? -eq 0 ]; then
            echo -n "."
        else
            echo "[FAILED]"
            exit
        fi
        let i=i+1
    done
    echo "done."
}

write_pattern ()
{
    #generate a file full of  PAT: a patterm should be of 4 bytes example : \xff\xff\xff\xff
    PAT=$1

    #TODO add a check for the pattern 
    echo writting with pattern=$1
    PAT_64=$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT
    PAT_1024=$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64
    printf $PAT_1024 >  /tmp/mtd_w_pat

    i=0
    while [ $i -lt $(( ${MTD_SIZE} /1024 ))  ]; do
        ${MTF_CMD} write ${MTD_DEV}  $(( ${i} * 1024 )) 1024  /tmp/mtd_w_pat &>/dev/null

        if [ $? -eq 0 ]; then
            echo -n "."
        else
            echo "$0 FAILED"
            exit
        fi
        let i=i+1
    done

    echo "done."
}

check_pattern ()
{
    echo  checking pattern=$1
    PAT=$1
    PAT_64=$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT$PAT
    PAT_1024=$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64$PAT_64

    zero_file   /tmp/mtd_block 

    i=0
    while [ $i -lt   $(( ${MTD_ERASE_SIZE} / 1024 ))  ]; do
        printf $PAT_1024 >> /tmp/mtd_block
        let i=i+1
    done

    i=0
    while [  $i -lt ${NBRE_BLOCK}  ] ; do
        ${MTF_CMD} read ${MTD_DEV} $(( ${i} * ${MTD_ERASE_SIZE} )) ${MTD_ERASE_SIZE} /tmp/mtd_b_$i.dump &>/dev/null
        cmp  /tmp/mtd_b_$i.dump  /tmp/mtd_block
        if [ $? -eq 0 ]; then
            echo -n "."
        else
            echo "$0 [FAILED]"
            exit
        fi
        let i=i+1
    done
    echo "done."
}

bit_by_bit ()
{
    byte=0

    while [ $byte -lt MTD_SIZE ]; do

        bit=0
        while [  $bit -lt 8  ] ; do
            echo $bit
                let bit=bit+1
        done
    done


}

select_partition ()
{
    partition_found=0
    while [ $partition_found -eq 0 ]; do

        echo "Selection of the MTD partion to test"
        cat /proc/mtd
        echo "please indicate the mtd partition number"
        read partition_number
        if [ -c /dev/mtd$partition_number ]; then 
            ${MTF_CMD} info /dev/mtd$partition_number 
            if [ $? -eq 0 ]; then
                export MTD_DEV=/dev/mtd$partition_number
                echo  "Selection Partion $MTD_DEV OK"
                #Calculation here
                export MTD_ERASE_SIZE=$(${MTF_CMD} info /dev/mtd$partition_number | grep "mtd.erasesize" | sed 's/[^ ]* = \([0-9]*\) .*/\1/')
                echo "erase size = $MTD_ERASE_SIZE"

                # Calucalte MTD SIZE
                export MTD_SIZE=$(${MTF_CMD} info /dev/mtd$partition_number | grep "mtd.size" | sed 's/[^ ]* = \([0-9]*\) .*/\1/')
                echo "partition size = $MTD_SIZE"

                export NBRE_BLOCK=$(( ${MTD_SIZE} / ${MTD_ERASE_SIZE} ))
                let partition=1
                return
            fi
        fi
        echo "Partiotion /dev/mtd$partition_number is not valid"
    done
}

menu ()
{
    exit_flag=0
    while [ $exit_flag -eq 0 ] ; do
        echo "Select the operation to perform :"
        echo "1) eraseall"
        echo "2) check eraseall"
        echo "3) write a pattern"
        echo "4) check a pattern"
        echo "5) mtdtest 1"
        echo "6) mtdtest 2"
        echo "7) exit"
        read case
        case $case in
            1) erase_all ;;
            2) test_erase ;;
            3) echo "writing a pattern:"
               echo "Please enter the pattern in the format "ff" where f in [0-f]"
               read pat
               write_pattern "\x$pat\x$pat\x$pat\x$pat" ;;
            4) echo "checking a pattern:"
               echo "Please enter the pattern in the format "ff" where f in [0-f]"
               read pat
               check_pattern "\x$pat\x$pat\x$pat\x$pat" ;;
            5) echo "Starting test suite N 1"
                erase_all 
                test_erase 
                check_pattern "\xff\xff\xff\xff"
                write_pattern "\xf0\xf0\xf0\xf0"
                check_pattern "\xf0\xf0\xf0\xf0"
                write_pattern "\x0f\x0f\x0f\x0f"
                check_pattern "\x00\x00\x00\x00"
                erase_all 
                test_erase  ;;
            6) echo "Starting test suite N 2"
                erase_all 
                test_erase 
                write_pattern "\xa5\xa5\xa5\xa5"
                check_pattern "\xa5\xa5\xa5\xa5"
                erase_all ;;

            7) echo "Bye."
                let exit_flag=1;;
        esac
    done
}

select_partition
menu
