ifeq ($(notdir $(CC)),gcc)
  SAMBA_FULL_CONFIGURATION:=$(SAMBA_FULL_CONFIGURATION) --host=i386-linux --enable-shared --with-gnu-ld
  CONFIG_SITE=
else
  SAMBA_FULL_CONFIGURATION:=$(SAMBA_FULL_CONFIGURATION) --build=i386-linux --host=mips-linux 
  CONFIG_SITE=../config.livebox
endif
export SAMBA_FULL_CONFIGURATION

SAMBA_SOURCE=source

all: samba

$(SAMBA_SOURCE)/include/stamp-h: $(STAGINGDIR)/components.config
	cd $(SAMBA_SOURCE) && \
		CONFIG_SITE=$(CONFIG_SITE) ./configure --prefix=/usr \
							  --with-privatedir=/var/etc/samba \
							  --with-lockdir=/var/etc/samba \
							  --with-piddir=/var/etc/samba $(SAMBA_FULL_CONFIGURATION) \
							  --with-configdir=/var/etc/samba \
							  --disable-cups \
							  --disable-iprint \
							  --disable-pie \
							  --disable-fam \
							  --without-ldap \
					  		  --without-libaddns \
							  --without-cifsmount \
							  --without-sendfile-support \
							  CFLAGS="-Os -DSAH_NO_PRINTING -D_FILE_OFFSET_BITS=64 -ffunction-sections -fdata-sections" \
							  LDFLAGS="-Wl,--gc-sections"


samba: $(SAMBA_SOURCE)/include/stamp-h
	make -C $(SAMBA_SOURCE) bin/nmbd
	make -C $(SAMBA_SOURCE) bin/smbd

clean:
	make -C $(SAMBA_SOURCE) clean

install:
	echo "Install SAMBA to: " $(STAGINGDIR)
	$(INSTALL) -d $(STAGINGDIR)/sbin
	$(INSTALL) -m 755 ./source/bin/smbd $(STAGINGDIR)/sbin
	$(INSTALL) -m 755 ./source/bin/nmbd $(STAGINGDIR)/sbin

release:
	echo "Release SAMBA to: $(ROOT_FS_DIR)"
	$(INSTALL) -d 0755 $(ROOT_FS_DIR)/sbin
	$(INSTALL) -m 0755 $(STAGINGDIR)/sbin/nmbd $(ROOT_FS_DIR)/sbin/nmbd
	$(STRIP) $(ROOT_FS_DIR)/sbin/nmbd
	$(INSTALL) -m 0755 $(STAGINGDIR)/sbin/smbd $(ROOT_FS_DIR)/sbin/smbd
	$(STRIP) $(ROOT_FS_DIR)/sbin/smbd
	$(INSTALL) -d 0755 $(ROOT_FS_DIR)/var/samba

.PHONY: all samba clean install release


